--- ../horde/lib/Horde/MIME.php	2008-01-06 00:01:50.000000000 +0800
+++ lib/Horde/MIME.php	2008-01-06 22:33:52.000000000 +0800
@@ -139,7 +139,12 @@
         }
 
         /* Get the list of elements in the string. */
-        $size = preg_match_all('/([^\s]+)([\s]*)/', $text, $matches, PREG_SET_ORDER);
+        mb_regex_encoding($charset);
+        mb_ereg_search_init($text, '([^[:space:]]+)([[:space:]]*)');
+        $matches = array();
+        while ($match = mb_ereg_search_regs()) {
+            $size = array_push($matches, $match);
+        }
 
         foreach ($matches as $key => $val) {
             if (MIME::is8bit($val[1])) {
@@ -170,25 +175,15 @@
      */
     function _encode($text, $charset)
     {
-        $encoded = trim(base64_encode($text));
         $c_size = strlen($charset) + 7;
-
-        if ((strlen($encoded) + $c_size) > 75) {
-            $parts = explode("\r\n", rtrim(chunk_split($encoded, intval((75 - $c_size) / 4) * 4)));
-        } else {
-            $parts[] = $encoded;
-        }
-
-        $p_size = count($parts);
-        $out = '';
-        foreach ($parts as $key => $val) {
-            $out .= '=?' . $charset . '?b?' . $val . '?=';
-            if ($p_size > $key + 1) {
-                /* RFC 2047 [2] states that no encoded word can be more than
-                 * 75 characters long. If longer, you must split the word with
-                 * CRLF SPACE. */
-                $out .= "\r\n ";
-            }
+        /* RFC 2047 [2] states that no encoded word can be more than
+         * 75 characters long. If longer, you must split the word with
+         * CRLF SPACE. */
+        $first_part = mb_strcut($text, 0, intval((75 - $c_size) / 4) * 3, $charset);
+        $rest = substr($text, strlen($first_part));
+        $out = '=?' . $charset . '?b?' . trim(base64_encode($first_part)) . '?=';
+        if ($rest) {
+            $out .= "\r\n" . MIME::_encode($rest, $charset);
         }
 
         return $out;
